commit 921420df1c7bbe39b997e28e78a3a72f6fcc9d31
Author: Geoffrey Richardson <information@kivitendo-premium.de>
Date:   Mon Aug 10 15:20:01 2015 +0200

    Typos - kein "wether" mehr!

diff --git a/SL/Controller/CsvImport/Inventory.pm b/SL/Controller/CsvImport/Inventory.pm
index c1406d059..e35aac65b 100644
--- a/SL/Controller/CsvImport/Inventory.pm
+++ b/SL/Controller/CsvImport/Inventory.pm
@@ -148,7 +148,7 @@ sub check_warehouse {
     $object->warehouse_id($wh->id);
   }
 
-  # Check wether or not warehouse ID is valid.
+  # Check whether or not warehouse ID is valid.
   if ($object->warehouse_id && !$self->warehouses_by->{id}->{ $object->warehouse_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid warehouse');
     return 0;
@@ -206,7 +206,7 @@ sub check_bin {
     $object->bin_id($bin->id);
   }
 
-  # Check wether or not bin ID is valid.
+  # Check whether or not bin ID is valid.
   if ($object->bin_id && !$self->bins_by->{_wh_id_and_id_ident()}->{ _wh_id_and_id_maker($object->warehouse_id, $object->bin_id) }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid bin');
     return 0;
@@ -238,7 +238,7 @@ sub check_part {
 
   my $object = $entry->{object};
 
-  # Check wether or non part ID is valid.
+  # Check whether or not part ID is valid.
   if ($object->parts_id && !$self->parts_by->{id}->{ $object->parts_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid part');
     return 0;
diff --git a/SL/Controller/CsvImport/Order.pm b/SL/Controller/CsvImport/Order.pm
index f8dbbb1cb..e0935c0e6 100644
--- a/SL/Controller/CsvImport/Order.pm
+++ b/SL/Controller/CsvImport/Order.pm
@@ -436,7 +436,7 @@ sub check_part {
 
   my $object = $entry->{object};
 
-  # Check wether or not part ID is valid.
+  # Check whether or not part ID is valid.
   if ($object->parts_id && !$self->parts_by->{id}->{ $object->parts_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid part');
     return 0;
@@ -482,7 +482,7 @@ sub check_contact {
   my $cp_cv_id = $object->customer_id || $object->vendor_id;
   return 0 unless $cp_cv_id;
 
-  # Check wether or not contact ID is valid.
+  # Check whether or not contact ID is valid.
   if ($object->cp_id && !$self->contacts_by->{'cp_cv_id+cp_id'}->{ $cp_cv_id . '+' . $object->cp_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid contact');
     return 0;
@@ -511,7 +511,7 @@ sub check_department {
 
   my $object = $entry->{object};
 
-  # Check wether or not department ID is valid.
+  # Check whether or not department ID is valid.
   if ($object->department_id && !$self->departments_by->{id}->{ $object->department_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid department');
     return 0;
@@ -540,7 +540,7 @@ sub check_project {
 
   my $object = $entry->{object};
 
-  # Check wether or not projetc ID is valid.
+  # Check whether or not projetc ID is valid.
   if ($object->$id_column && !$self->projects_by->{id}->{ $object->$id_column }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid project');
     return 0;
@@ -579,7 +579,7 @@ sub check_ct_shipto {
   my $trans_id = $object->customer_id || $object->vendor_id;
   return 0 unless $trans_id;
 
-  # Check wether or not shipto ID is valid.
+  # Check whether or not shipto ID is valid.
   if ($object->shipto_id && !$self->ct_shiptos_by->{'trans_id+shipto_id'}->{ $trans_id . '+' . $object->shipto_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid shipto');
     return 0;
@@ -593,7 +593,7 @@ sub check_price_factor {
 
   my $object = $entry->{object};
 
-  # Check wether or not price_factor ID is valid.
+  # Check whether or not price_factor ID is valid.
   if ($object->price_factor_id && !$self->price_factors_by->{id}->{ $object->price_factor_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid price factor');
     return 0;
@@ -618,7 +618,7 @@ sub check_pricegroup {
 
   my $object = $entry->{object};
 
-  # Check wether or not pricegroup ID is valid.
+  # Check whether or not pricegroup ID is valid.
   if ($object->pricegroup_id && !$self->pricegroups_by->{id}->{ $object->pricegroup_id }) {
     push @{ $entry->{errors} }, $::locale->text('Error: Invalid price group');
     return 0;
diff --git a/sql/Pg-upgrade2/project_bob_attributes.sql b/sql/Pg-upgrade2/project_bob_attributes.sql
index 88ea42fd8..ef2224c3b 100644
--- a/sql/Pg-upgrade2/project_bob_attributes.sql
+++ b/sql/Pg-upgrade2/project_bob_attributes.sql
@@ -9,7 +9,7 @@
 -- varchars retyped to text
 -- hours (numeric) changed to minutes (integer) since the code already calculates in minutes
 --  note: flags changing the behaviour of hours are still called so and not minutes
--- no refcounts. we use adhoc counts to decide wether delete is possible or not
+-- no refcounts. we use adhoc counts to decide whether delete is possible or not
 -- no hour_approval
 -- nothing relevant to notifications
 
diff --git a/t/002goodperl.t b/t/002goodperl.t
index 0434ab89b..1f3a611d8 100644
--- a/t/002goodperl.t
+++ b/t/002goodperl.t
@@ -106,7 +106,7 @@ foreach my $file (@testitems) {
 
 # note, the html checker is not really thorough.
 # in particular it will not find standard tags with parameters.
-# the estimate wether a file is dirty or not is still pretty helpful, as it will catch most of the closing tags.
+# the estimate whether a file is dirty or not is still pretty helpful, as it will catch most of the closing tags.
 # if you are in doubt about a specific file, you still have to check it manually.
 my $tags = qr/b|i|u|h[1-6]|a href.*|input|form|br|textarea|table|tr|td|th|body|head|html|p|button|select|option|script/;
 my $todo_files_re = qr{^bin/mozilla/ic\.pl$};
diff --git a/t/006spellcheck.t b/t/006spellcheck.t
index e741cdd62..e3f2ac60c 100644
--- a/t/006spellcheck.t
+++ b/t/006spellcheck.t
@@ -48,6 +48,7 @@ sekf
 sucess
 varsion
 pirce
+wether
 );
 
 $testcount = scalar(@Support::Files::testitems);
diff --git a/templates/webpages/generic/multibox.html b/templates/webpages/generic/multibox.html
index 28ff8370f..bf39fe8a8 100644
--- a/templates/webpages/generic/multibox.html
+++ b/templates/webpages/generic/multibox.html
@@ -3,7 +3,7 @@
      Multibox
 
   This template makes an input box for you,
-  decides wether it should be a text field or a drop down box,
+  decides whether it should be a text field or a drop down box,
   generates the HTML code, and fixes everything just right.
 
   call:  PROCESS generic/multibox.html var = var, var2 = ....