commit d6a2112059bfd74eaa3926b8f9d1cfb52bf0e2f4
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Tue Sep 29 16:40:11 2015 +0200

    Mahnungen: Rechnungen mit Lastschrifteinzug nur auf Wunsch mit anzeigen

diff --git a/SL/DN.pm b/SL/DN.pm
index 55200835e..0ada08c4d 100644
--- a/SL/DN.pm
+++ b/SL/DN.pm
@@ -523,11 +523,16 @@ sub get_invoices {
        WHERE dunning_level = (SELECT MAX(dunning_level) FROM dunning_config)|;
   my ($id_for_max_dunning_level) = selectrow_query($form, $dbh, $query);
 
+  if (!$form->{l_include_direct_debit}) {
+    $where .= qq| AND NOT COALESCE(a.direct_debit, FALSE) |;
+  }
+
   $query =
     qq|SELECT
          a.id, a.ordnumber, a.transdate, a.invnumber, a.amount, a.language_id,
          ct.name AS customername, a.customer_id, a.duedate,
          a.amount - a.paid AS open_amount,
+         a.direct_debit,
 
          cfg.dunning_description, cfg.dunning_level,
 
diff --git a/css/common.css b/css/common.css
index 2594ef665..fe764b82e 100644
--- a/css/common.css
+++ b/css/common.css
@@ -66,3 +66,9 @@ input.grow_on_focus:focus { width: 150px }
 .cursor-default { cursor: default }
 .cursor-pointer { cursor: pointer }
 .cursor-help { cursor: help }
+
+/* dunning */
+#dunning_invoice_list .direct_debit td,
+#dunning_invoice_list .direct_debit a {
+  color: #aaa;
+}
diff --git a/locale/de/all b/locale/de/all
index d4bac8359..9fedf0f55 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -1377,6 +1377,7 @@ $self->{texts} = {
   'Include in Report'           => 'In Bericht aufnehmen',
   'Include in drop-down menus'  => 'In Aufklappmenü aufnehmen',
   'Include invalid warehouses ' => 'Ungültige Lager berücksichtigen',
+  'Include invoices with direct debit' => 'Inklusive Rechnungen mit Lastschrifteinzug',
   'Includeable in reports'      => 'In Berichten anzeigbar',
   'Included in reports by default' => 'In Berichten standardmäßig enthalten',
   'Including'                   => 'Enthaltene',
diff --git a/templates/webpages/dunning/add.html b/templates/webpages/dunning/add.html
index b7898c632..4173a51af 100644
--- a/templates/webpages/dunning/add.html
+++ b/templates/webpages/dunning/add.html
@@ -70,8 +70,13 @@
    </tr>
 
    <tr>
-    <th align="right" nowrap>[% 'Group Invoices' | $T8 %]</th>
-    <td><input type="checkbox" value="1" name="groupinvoices" checked></td>
+    <th align="right" nowrap><label for="groupinvoices">[% 'Group Invoices' | $T8 %]</label></th>
+    <td><input type="checkbox" value="1" id="groupinvoices" name="groupinvoices" checked></td>
+   </tr>
+
+   <tr>
+    <th align="right" nowrap><label for="l_include_direct_debit">[% 'Include invoices with direct debit' | $T8 %]</label></th>
+    <td><input type="checkbox" value="1" id="l_include_direct_debit" name="l_include_direct_debit"></td>
    </tr>
   </table>
 
diff --git a/templates/webpages/dunning/show_invoices.html b/templates/webpages/dunning/show_invoices.html
index d087ec96d..63e50397d 100644
--- a/templates/webpages/dunning/show_invoices.html
+++ b/templates/webpages/dunning/show_invoices.html
@@ -1,6 +1,6 @@
 [%- USE T8 %]
 [% USE HTML %]
-[% USE L %]
+[% USE L %][%- USE LxERP -%]
 <h1>[% title %]</h1>
 
 [% SET all_active = 1 %][% FOREACH row = DUNNINGS %][% IF !row.active %][% SET all_active = 0 %][% LAST %][% END %][% END %]
@@ -12,7 +12,7 @@
 
  <form name="Form" method="post" action="dn.pl">
 
-  <table width="100%">
+  <table width="100%" id="dunning_invoice_list">
    <th class="listheading" colspan="2">[% 'Current / Next Level' | $T8 %]</th>
 
    <th class="listheading">
@@ -35,11 +35,14 @@
    <th class="listheading">[% 'Dunning Duedate' | $T8 %]</th>
    <th class="listheading">[% 'Total Fees' | $T8 %]</th>
    <th class="listheading">[% 'Interest' | $T8 %]</th>
+   [% IF l_include_direct_debit %]
+    <th class="listheading">[% 'direct debit' | $T8 %]</th>
+   [% END %]
 
    <!-- Ausgabe der einzelnen Zeilen -->
 
    [% FOREACH row = DUNNINGS %]
-    <tr class="listrow[% loop.count % 2 %]">
+    <tr class="listrow[% loop.count % 2 %][% IF row.direct_debit %] direct_debit[% END %]">
 
      <td>
       <input type="hidden" name="inv_id_[% loop.count %]" size="2" value="[% HTML.escape(row.id) %]">
@@ -68,6 +71,11 @@
      <td>[% HTML.escape(row.next_duedate) %]</td>
      <td align="right"><input type="hidden" name="fee_[% loop.count %]" size="6" value="[% HTML.escape(row.fee) %]">[% HTML.escape(row.fee) %]</td>
      <td align="right"><input type="hidden" name="interest_[% loop.count %]" size="6" value="[% HTML.escape(row.interest) %]">[% HTML.escape(row.interest) %]</td>
+     [% IF l_include_direct_debit %]
+     <td>
+      [% IF row.direct_debit %][% LxERP.t8("yes") %][% ELSE %][% LxERP.t8("no") %][% END %]
+     </td>
+     [% END %]
     </tr>
    [% END %]
   </table>